]> git.ipfire.org Git - thirdparty/git.git/blame - git-fetch.sh
When creating branch c/d check that branch c does not already exists.
[thirdparty/git.git] / git-fetch.sh
CommitLineData
7ef76925
LT
1#!/bin/sh
2#
87358b7a
FK
3
4USAGE='<fetch-options> <repository> <refspec>...'
ae2b0f15 5. git-sh-setup
215a7ad1 6. git-parse-remote
853a3697
JH
7_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
9
221e743c
JH
10LF='
11'
12IFS="$LF"
13
55b7835e 14rloga=fetch
03febf99 15no_tags=
ed1aadf1 16tags=
853a3697 17append=
ae2da406 18force=
583122cd 19verbose=
b10ac50f 20update_head_ok=
2c620a1a 21exec=
96b086d6 22upload_pack=
482faa8d 23keep=--thin
ae2da406
JH
24while case "$#" in 0) break ;; esac
25do
26 case "$1" in
27 -a|--a|--ap|--app|--appe|--appen|--append)
28 append=t
ae2da406 29 ;;
2796a9de
JH
30 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
2c620a1a
MO
32 shift
33 exec="--exec=$1"
96b086d6 34 upload_pack="-u $1"
2c620a1a 35 ;;
ae2da406
JH
36 -f|--f|--fo|--for|--forc|--force)
37 force=t
b10ac50f 38 ;;
ed1aadf1
LT
39 -t|--t|--ta|--tag|--tags)
40 tags=t
41 ;;
03febf99
JH
42 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
43 no_tags=t
44 ;;
b10ac50f
JH
45 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
48 update_head_ok=t
ae2da406 49 ;;
583122cd
LT
50 -v|--verbose)
51 verbose=Yes
52 ;;
0f76f526
TP
53 -k|--k|--ke|--kee|--keep)
54 keep=--keep
55 ;;
55b7835e
SP
56 --reflog-action=*)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
58 ;;
87358b7a
FK
59 -*)
60 usage
61 ;;
ae2da406
JH
62 *)
63 break
64 ;;
65 esac
b10ac50f 66 shift
ae2da406
JH
67done
68
853a3697
JH
69case "$#" in
700)
648ad18f
SB
71 origin=$(get_default_remote)
72 test -n "$(get_remote_url ${origin})" ||
73 die "Where do you want to fetch from today?"
74 set x $origin ; shift ;;
853a3697 75esac
ae2da406 76
853a3697
JH
77remote_nick="$1"
78remote=$(get_remote_url "$@")
79refs=
80rref=
81rsync_slurped_objects=
82
55b7835e 83rloga="$rloga $remote_nick"
ed0e078f 84test "$remote_nick" = "$remote" || rloga="$rloga $remote"
55b7835e 85
853a3697
JH
86if test "" = "$append"
87then
df34297a 88 : >"$GIT_DIR/FETCH_HEAD"
853a3697
JH
89fi
90
91append_fetch_head () {
92 head_="$1"
93 remote_="$2"
94 remote_name_="$3"
95 remote_nick_="$4"
96 local_name_="$5"
05dd8e2e
JH
97 case "$6" in
98 t) not_for_merge_='not-for-merge' ;;
99 '') not_for_merge_= ;;
100 esac
853a3697 101
06ec2b4b
JH
102 # remote-nick is the URL given on the command line (or a shorthand)
103 # remote-name is the $GIT_DIR relative refs/ path we computed
104 # for this refspec.
687b8be8
EW
105
106 # the $note_ variable will be fed to git-fmt-merge-msg for further
107 # processing.
06ec2b4b
JH
108 case "$remote_name_" in
109 HEAD)
110 note_= ;;
111 refs/heads/*)
112 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
b91fb518 113 note_="branch '$note_' of " ;;
06ec2b4b
JH
114 refs/tags/*)
115 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
b91fb518 116 note_="tag '$note_' of " ;;
687b8be8
EW
117 refs/remotes/*)
118 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
119 note_="remote branch '$note_' of " ;;
06ec2b4b 120 *)
b91fb518 121 note_="$remote_name of " ;;
06ec2b4b 122 esac
f327dbce 123 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
b91fb518
JH
124 remote_="$remote_1_"
125 note_="$note_$remote_"
06ec2b4b 126
853a3697
JH
127 # 2.6.11-tree tag would not be happy to be fed to resolve.
128 if git-cat-file commit "$head_" >/dev/null 2>&1
129 then
8572aa85 130 headc_=$(git-rev-parse --verify "$head_^0") || exit
df34297a 131 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
132 [ "$verbose" ] && echo >&2 "* committish: $head_"
133 [ "$verbose" ] && echo >&2 " $note_"
853a3697 134 else
df34297a 135 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
583122cd
LT
136 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
137 [ "$verbose" ] && echo >&2 " $note_"
853a3697
JH
138 fi
139 if test "$local_name_" != ""
140 then
141 # We are storing the head locally. Make sure that it is
142 # a fast forward (aka "reverse push").
06ec2b4b 143 fast_forward_local "$local_name_" "$head_" "$note_"
853a3697
JH
144 fi
145}
146
147fast_forward_local () {
866ff2f7 148 mkdir -p "$(dirname "$GIT_DIR/$1")"
853a3697
JH
149 case "$1" in
150 refs/tags/*)
151 # Tags need not be pointing at commits so there
152 # is no way to guarantee "fast-forward" anyway.
ae2da406
JH
153 if test -f "$GIT_DIR/$1"
154 then
f8765797
JH
155 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
156 then
7eae7b99 157 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
f8765797
JH
158 else
159 echo >&2 "* $1: updating with $3"
55b7835e 160 git-update-ref -m "$rloga: updating tag" "$1" "$2"
f8765797 161 fi
ae2da406 162 else
06ec2b4b 163 echo >&2 "* $1: storing $3"
55b7835e 164 git-update-ref -m "$rloga: storing tag" "$1" "$2"
ae2da406 165 fi
bf7960eb 166 ;;
ae2da406 167
687b8be8 168 refs/heads/* | refs/remotes/*)
bf7960eb
JH
169 # $1 is the ref being updated.
170 # $2 is the new value for the ref.
171 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
172 if test "$local"
33b83034 173 then
bf7960eb 174 # Require fast-forward.
853a3697
JH
175 mb=$(git-merge-base "$local" "$2") &&
176 case "$2,$mb" in
177 $local,*)
ea5aeb07
JH
178 if test -n "$verbose"
179 then
180 echo >&2 "* $1: same as $3"
181 fi
853a3697
JH
182 ;;
183 *,$local)
06ec2b4b 184 echo >&2 "* $1: fast forward to $3"
9d7f73d4 185 echo >&2 " from $local to $2"
55b7835e 186 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
853a3697
JH
187 ;;
188 *)
189 false
190 ;;
191 esac || {
06ec2b4b 192 echo >&2 "* $1: does not fast forward to $3;"
bf7960eb
JH
193 case ",$force,$single_force," in
194 *,t,*)
06ec2b4b 195 echo >&2 " forcing update."
55b7835e 196 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
ae2da406
JH
197 ;;
198 *)
bf7960eb 199 echo >&2 " not updating."
a9698bb2 200 exit 1
ae2da406
JH
201 ;;
202 esac
853a3697
JH
203 }
204 else
bf7960eb 205 echo >&2 "* $1: storing $3"
55b7835e 206 git-update-ref -m "$rloga: storing head" "$1" "$2"
33b83034 207 fi
0a623e7c 208 ;;
853a3697
JH
209 esac
210}
211
b10ac50f
JH
212case "$update_head_ok" in
213'')
bf7960eb 214 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
215 ;;
216esac
217
ed1aadf1
LT
218# If --tags (and later --heads or --all) is specified, then we are
219# not talking about defaults stored in Pull: line of remotes or
220# branches file, and just fetch those and refspecs explicitly given.
221# Otherwise we do what we always did.
222
223reflist=$(get_remote_refs_for_fetch "$@")
224if test "$tags"
225then
878ccb26 226 taglist=`IFS=" " &&
57a39690
JH
227 (
228 git-ls-remote $upload_pack --tags "$remote" ||
229 echo fail ouch
230 ) |
81214e4d
JH
231 while read sha1 name
232 do
57a39690
JH
233 case "$sha1" in
234 fail)
235 exit 1
236 esac
81214e4d 237 case "$name" in
878ccb26 238 *^*) continue ;;
81214e4d
JH
239 esac
240 if git-check-ref-format "$name"
241 then
242 echo ".${name}:${name}"
243 else
244 echo >&2 "warning: tag ${name} ignored"
245 fi
57a39690 246 done` || exit
ed1aadf1
LT
247 if test "$#" -gt 1
248 then
249 # remote URL plus explicit refspecs; we need to merge them.
221e743c 250 reflist="$reflist$LF$taglist"
ed1aadf1
LT
251 else
252 # No explicit refspecs; fetch tags only.
253 reflist=$taglist
254 fi
255fi
256
03febf99
JH
257fetch_main () {
258 reflist="$1"
259 refs=
f170e4b3 260
03febf99
JH
261 for ref in $reflist
262 do
263 refs="$refs$LF$ref"
f170e4b3 264
03febf99
JH
265 # These are relative path from $GIT_DIR, typically starting at refs/
266 # but may be HEAD
f327dbce 267 if expr "z$ref" : 'z\.' >/dev/null
03febf99
JH
268 then
269 not_for_merge=t
f327dbce 270 ref=$(expr "z$ref" : 'z\.\(.*\)')
03febf99
JH
271 else
272 not_for_merge=
273 fi
dfdcb558 274 if expr "z$ref" : 'z+' >/dev/null
03febf99
JH
275 then
276 single_force=t
dfdcb558 277 ref=$(expr "z$ref" : 'z+\(.*\)')
03febf99
JH
278 else
279 single_force=
280 fi
f327dbce
MW
281 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
282 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
853a3697 283
03febf99 284 rref="$rref$LF$remote_name"
4447badc 285
03febf99
JH
286 # There are transports that can fetch only one head at a time...
287 case "$remote" in
38529e28 288 http://* | https://* | ftp://*)
03febf99
JH
289 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
290 curl_extra_args="-k"
291 fi
093b0688
NH
292 max_depth=5
293 depth=0
294 head="ref: $remote_name"
295 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
296 do
d9bffc08 297 remote_name_quoted=$(@@PERL@@ -e '
03febf99 298 my $u = $ARGV[0];
093b0688 299 $u =~ s/^ref:\s*//;
03febf99
JH
300 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
301 print "$u";
093b0688
NH
302 ' "$head")
303 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
304 depth=$( expr \( $depth + 1 \) )
305 done
f327dbce 306 expr "z$head" : "z$_x40\$" >/dev/null ||
093b0688 307 die "Failed to fetch $remote_name from $remote"
03febf99
JH
308 echo >&2 Fetching "$remote_name from $remote" using http
309 git-http-fetch -v -a "$head" "$remote/" || exit
310 ;;
311 rsync://*)
312 TMP_HEAD="$GIT_DIR/TMP_HEAD"
313 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
314 head=$(git-rev-parse --verify TMP_HEAD)
315 rm -f "$TMP_HEAD"
316 test "$rsync_slurped_objects" || {
317 rsync -av --ignore-existing --exclude info \
318 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
853a3697 319
03febf99
JH
320 # Look at objects/info/alternates for rsync -- http will
321 # support it natively and git native ones will do it on
322 # the remote end. Not having that file is not a crime.
323 rsync -q "$remote/objects/info/alternates" \
324 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
325 rm -f "$GIT_DIR/TMP_ALT"
326 if test -f "$GIT_DIR/TMP_ALT"
327 then
328 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
329 while read alt
330 do
331 case "$alt" in 'bad alternate: '*) die "$alt";; esac
332 echo >&2 "Getting alternate: $alt"
333 rsync -av --ignore-existing --exclude info \
334 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
335 done
336 rm -f "$GIT_DIR/TMP_ALT"
337 fi
338 rsync_slurped_objects=t
339 }
340 ;;
341 *)
342 # We will do git native transport with just one call later.
343 continue ;;
344 esac
f170e4b3 345
03febf99
JH
346 append_fetch_head "$head" "$remote" \
347 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
853a3697 348
03febf99
JH
349 done
350
351 case "$remote" in
38529e28 352 http://* | https://* | ftp://* | rsync://* )
03febf99
JH
353 ;; # we are already done.
354 *)
355 ( : subshell because we muck with IFS
356 IFS=" $LF"
357 (
482faa8d 358 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
03febf99
JH
359 ) |
360 while read sha1 remote_name
361 do
362 case "$sha1" in
363 failed)
364 echo >&2 "Fetch failure: $remote"
365 exit 1 ;;
366 esac
367 found=
368 single_force=
369 for ref in $refs
370 do
371 case "$ref" in
372 +$remote_name:*)
373 single_force=t
374 not_for_merge=
375 found="$ref"
376 break ;;
377 .+$remote_name:*)
378 single_force=t
379 not_for_merge=t
380 found="$ref"
381 break ;;
382 .$remote_name:*)
383 not_for_merge=t
384 found="$ref"
385 break ;;
386 $remote_name:*)
387 not_for_merge=
388 found="$ref"
389 break ;;
390 esac
391 done
f327dbce 392 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
03febf99
JH
393 append_fetch_head "$sha1" "$remote" \
394 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
395 done
396 ) || exit ;;
397 esac
398
399}
400
401fetch_main "$reflist"
402
403# automated tag following
404case "$no_tags$tags" in
405'')
6dc78e69
JH
406 case "$reflist" in
407 *:refs/*)
408 # effective only when we are following remote branch
409 # using local tracking branch.
410 taglist=$(IFS=" " &&
411 git-ls-remote $upload_pack --tags "$remote" |
412 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
413 while read sha1 name
414 do
415 test -f "$GIT_DIR/$name" && continue
416 git-check-ref-format "$name" || {
417 echo >&2 "warning: tag ${name} ignored"
418 continue
419 }
420 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
421 echo >&2 "Auto-following $name"
422 echo ".${name}:${name}"
423 done)
424 esac
03febf99
JH
425 case "$taglist" in
426 '') ;;
427 ?*)
428 fetch_main "$taglist" ;;
429 esac
853a3697 430esac
b10ac50f
JH
431
432# If the original head was empty (i.e. no "master" yet), or
433# if we were told not to worry, we do not have to check.
434case ",$update_head_ok,$orig_head," in
435*,, | t,* )
436 ;;
437*)
bf7960eb 438 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
b10ac50f
JH
439 if test "$curr_head" != "$orig_head"
440 then
55b7835e
SP
441 git-update-ref \
442 -m "$rloga: Undoing incorrectly fetched HEAD." \
443 HEAD "$orig_head"
b10ac50f
JH
444 die "Cannot fetch into the current branch."
445 fi
446 ;;
447esac